'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _react = require('react');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _recompose = require('recompose');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ViewportScanner = function ViewportScanner(_ref) {
  var containerSelector = _ref.containerSelector,
      defaultBottomIsVisible = _ref.defaultBottomIsVisible,
      isLocked = _ref.isLocked,
      children = _ref.children;

  var _useState = (0, _react.useState)(defaultBottomIsVisible),
      _useState2 = (0, _slicedToArray3.default)(_useState, 2),
      bottomIsVisible = _useState2[0],
      setBottomIsVisibleTo = _useState2[1];

  var _useState3 = (0, _react.useState)(null),
      _useState4 = (0, _slicedToArray3.default)(_useState3, 2),
      containerElement = _useState4[0],
      setContainerElement = _useState4[1];

  var handleScroll = function handleScroll() {
    if (!isLocked) {
      if (containerElement.getBoundingClientRect().bottom > 0) {
        setBottomIsVisibleTo(true);
      } else {
        setBottomIsVisibleTo(false);
      }
    }
  };

  (0, _react.useEffect)(function () {
    if (typeof window !== 'undefined') {
      if (containerElement === null) {
        setContainerElement(document.querySelector(containerSelector));
      }
      window.addEventListener('scroll', handleScroll);
    }
    return function () {
      window.removeEventListener('scroll', handleScroll);
    };
  });

  return children({ bottomIsVisible: bottomIsVisible });
};

ViewportScanner.propTypes = {
  containerSelector: _propTypes2.default.string.isRequired
};
ViewportScanner.defaultProps = {
  defaultBottomIsVisible: true
};

var enhance = (0, _recompose.compose)((0, _recompose.onlyUpdateForKeys)(['containerSelector', 'children', 'isLocked']));

exports.default = enhance(ViewportScanner);